/*2:*/
#line 48 "23tree.w"

/*3:*/
#line 62 "23tree.w"


#include <stdio.h> 

/*:3*//*50:*/
#line 795 "23tree.w"


#include <malloc.h> 

/*:50*/
#line 49 "23tree.w"

/*12:*/
#line 212 "23tree.w"


#define POS_LEFT 000
#define POS_MATCH_FIRST 010
#define POS_MIDDLE 001
#define POS_MATCH_SECOND 020
#define POS_RIGHT 002

/*:12*//*13:*/
#line 230 "23tree.w"


#define MATCHED(code) ((code) & 070)
#define WHICH_MATCHED(code) (((code) >> 3) - 1)

/*:13*//*22:*/
#line 305 "23tree.w"


#define isleaf(node)  (node->child[0] == NULL)

/*:22*/
#line 50 "23tree.w"

/*4:*/
#line 78 "23tree.w"


typedef void*T23_KEY;

/*:4*//*5:*/
#line 95 "23tree.w"


typedef struct t23_st_node{
int numkeys;
T23_KEY key[2];
struct t23_st_node*child[3];
struct t23_st_node*parent;
}*T23;

/*:5*//*6:*/
#line 109 "23tree.w"


typedef int(*T23_COMPF)(T23_KEY,T23_KEY);

/*:6*//*9:*/
#line 157 "23tree.w"


typedef enum t23_en_bool{T23_FALSE= 0,T23_TRUE= 1}t23_boolean;

/*:9*/
#line 51 "23tree.w"

/*8:*/
#line 139 "23tree.w"


/*7:*/
#line 134 "23tree.w"


T23_KEY t23search(T23_KEY key,T23*rootp,T23_COMPF compf,
t23_boolean insert_on_success,t23_boolean insert_on_failure)

/*:7*/
#line 141 "23tree.w"
;

/*:8*//*15:*/
#line 242 "23tree.w"


/*14:*/
#line 238 "23tree.w"


int t23_aux_compare(T23_KEY key,T23 node,T23_COMPF compf)

/*:14*/
#line 244 "23tree.w"
;

/*:15*//*28:*/
#line 381 "23tree.w"


/*27:*/
#line 377 "23tree.w"


static int t23_up(T23 newnode,T23 oldnode,T23*rootp,T23_COMPF compf)

/*:27*/
#line 383 "23tree.w"
;

/*:28*//*37:*/
#line 619 "23tree.w"


/*36:*/
#line 615 "23tree.w"


T23_KEY t23first(T23 root)

/*:36*/
#line 621 "23tree.w"
;

/*:37*//*41:*/
#line 669 "23tree.w"


/*40:*/
#line 665 "23tree.w"


T23_KEY t23next(T23_KEY key,T23 root,T23_COMPF compf)

/*:40*/
#line 671 "23tree.w"
;

/*:41*//*48:*/
#line 766 "23tree.w"


/*47:*/
#line 762 "23tree.w"


static T23 makenewnode(T23_KEY key)

/*:47*/
#line 768 "23tree.w"
;

/*:48*//*52:*/
#line 805 "23tree.w"


/*51:*/
#line 801 "23tree.w"


static T23 leftmost_child(T23 node)

/*:51*/
#line 807 "23tree.w"
;

/*:52*/
#line 52 "23tree.w"


/*10:*/
#line 177 "23tree.w"


/*7:*/
#line 134 "23tree.w"


T23_KEY t23search(T23_KEY key,T23*rootp,T23_COMPF compf,
t23_boolean insert_on_success,t23_boolean insert_on_failure)

/*:7*/
#line 179 "23tree.w"
{

/*18:*/
#line 277 "23tree.w"


T23 cur= *rootp;
int direction;

/*:18*/
#line 181 "23tree.w"


/*25:*/
#line 336 "23tree.w"


if(*rootp==NULL){
if(insert_on_failure){
T23 newnode= makenewnode(key);
if(newnode==NULL)return NULL;
else*rootp= newnode;
}
return key;
}


/*:25*/
#line 183 "23tree.w"


for(;;){
/*17:*/
#line 270 "23tree.w"


direction= t23_aux_compare(key,cur,compf);

/*:17*/
#line 186 "23tree.w"


/*19:*/
#line 284 "23tree.w"


if(MATCHED(direction))

/*:19*/
#line 188 "23tree.w"
{
/*20:*/
#line 293 "23tree.w"


if(insert_on_success)cur->key[WHICH_MATCHED(direction)]= key;
return cur->key[WHICH_MATCHED(direction)];

/*:20*/
#line 189 "23tree.w"

}else if(/*21:*/
#line 301 "23tree.w"


(isleaf(cur))

/*:21*/
#line 190 "23tree.w"
){
/*24:*/
#line 319 "23tree.w"


if(insert_on_failure){
T23 newnode= makenewnode(key);

if(newnode!=NULL&&t23_up(newnode,cur,rootp,compf)==0)
return key;
else
return NULL;
}
return key;

/*:24*/
#line 191 "23tree.w"

}else{
/*23:*/
#line 309 "23tree.w"


cur= cur->child[direction];

/*:23*/
#line 193 "23tree.w"

}
}
}


/*:10*/
#line 54 "23tree.w"

/*38:*/
#line 627 "23tree.w"


/*36:*/
#line 615 "23tree.w"


T23_KEY t23first(T23 root)

/*:36*/
#line 629 "23tree.w"

{
T23 leftmostnode;

leftmostnode= leftmost_child(root);

return leftmostnode->key[0];
}

/*:38*/
#line 55 "23tree.w"

/*42:*/
#line 673 "23tree.w"

/*40:*/
#line 665 "23tree.w"


T23_KEY t23next(T23_KEY key,T23 root,T23_COMPF compf)

/*:40*/
#line 674 "23tree.w"

{
/*46:*/
#line 750 "23tree.w"


T23 oldnode;
int position;

/*:46*/
#line 676 "23tree.w"


oldnode= t23search(key,&root,compf,T23_FALSE,T23_FALSE);

position= WHICH_MATCHED(t23_aux_compare(key,oldnode,compf));

/*43:*/
#line 691 "23tree.w"


if(oldnode->child[position+1])
return leftmost_child(oldnode->child[position+1])->key[0];

/*:43*//*44:*/
#line 699 "23tree.w"


else if(position==0&&oldnode->numkeys==2)
return oldnode->key[1];

/*:44*//*45:*/
#line 714 "23tree.w"




while(oldnode->parent!=NULL){

position= t23_aux_compare(oldnode->key[0],oldnode->parent,compf);
oldnode= oldnode->parent;

switch(position){
case POS_LEFT:
return oldnode->key[0];
case POS_MIDDLE:
if(oldnode->numkeys==2)
return oldnode->key[1];

else break;
case POS_RIGHT:

break;
default:
fprintf(stderr,"T23 package internal logic bug #72\n");
return NULL;
}
}





return NULL;

/*:45*/
#line 682 "23tree.w"

}

/*:42*/
#line 56 "23tree.w"


/*11:*/
#line 203 "23tree.w"


/*16:*/
#line 246 "23tree.w"


/*14:*/
#line 238 "23tree.w"


int t23_aux_compare(T23_KEY key,T23 node,T23_COMPF compf)

/*:14*/
#line 248 "23tree.w"
{

int compresult;

compresult= (*compf)(key,node->key[0]);

if(compresult<0)return POS_LEFT;
else if(compresult==0)return POS_MATCH_FIRST;
else if(node->numkeys==1)return POS_MIDDLE;

compresult= (*compf)(key,node->key[1]);

if(compresult<0)return POS_MIDDLE;
else if(compresult==0)return POS_MATCH_SECOND;
else return POS_RIGHT;
}


/*:16*/
#line 205 "23tree.w"


/*:11*//*26:*/
#line 359 "23tree.w"


/*29:*/
#line 385 "23tree.w"


/*27:*/
#line 377 "23tree.w"


static int t23_up(T23 newnode,T23 oldnode,T23*rootp,T23_COMPF compf)

/*:27*/
#line 387 "23tree.w"
{

/*31:*/
#line 419 "23tree.w"


T23_KEY newkey= newnode->key[0];

/*:31*/
#line 389 "23tree.w"


for(;;){
/*30:*/
#line 406 "23tree.w"


if(oldnode->numkeys==1)

/*:30*/
#line 392 "23tree.w"
{
/*32:*/
#line 423 "23tree.w"


int position= t23_aux_compare(newkey,oldnode,compf);
int i;

switch(position){
case POS_LEFT:
oldnode->key[1]= oldnode->key[0];
oldnode->child[2]= oldnode->child[1];

oldnode->child[0]= newnode->child[0];
oldnode->key[0]= newkey;
oldnode->child[1]= newnode->child[1];
break;

case POS_MIDDLE:
oldnode->child[1]= newnode->child[0];
oldnode->key[1]= newkey;
oldnode->child[2]= newnode->child[1];
break;
default:
fprintf(stderr,"T23 package internal logic bug #7\n");
return-1;
}

oldnode->numkeys= 2;


for(i= 0;i<3;i++){
if(oldnode->child[i])
oldnode->child[i]->parent= oldnode;
}




free(newnode);

/*:32*/
#line 393 "23tree.w"

return 0;
}else{
/*33:*/
#line 472 "23tree.w"


int position= t23_aux_compare(newkey,oldnode,compf);
T23 leftnode,middlenode,rightnode;

switch(position){
case POS_LEFT:
leftnode= makenewnode(newkey);
middlenode= makenewnode(oldnode->key[0]);
rightnode= makenewnode(oldnode->key[1]);
break;
case POS_MIDDLE:
leftnode= makenewnode(oldnode->key[0]);
middlenode= makenewnode(newkey);
rightnode= makenewnode(oldnode->key[1]);
break;
case POS_RIGHT:
leftnode= makenewnode(oldnode->key[0]);
middlenode= makenewnode(oldnode->key[1]);
rightnode= makenewnode(newkey);
break;
default:
fprintf(stderr,"T23 package internal logic bug #8\n");
return-1;
}

if(leftnode==NULL||middlenode==NULL||rightnode==NULL)
return-1;


/*:33*/
#line 396 "23tree.w"

/*34:*/
#line 505 "23tree.w"








middlenode->child[0]= leftnode;
middlenode->child[1]= rightnode;
leftnode->parent= middlenode;
rightnode->parent= middlenode;

switch(position){
case POS_LEFT:
leftnode->child[0]= newnode->child[0];
leftnode->child[1]= newnode->child[1];
rightnode->child[0]= oldnode->child[1];
rightnode->child[1]= oldnode->child[2];
break;
case POS_MIDDLE:
leftnode->child[0]= oldnode->child[0];
leftnode->child[1]= newnode->child[0];
rightnode->child[0]= newnode->child[1];
rightnode->child[1]= oldnode->child[2];
break;
case POS_RIGHT:
leftnode->child[0]= oldnode->child[0];
leftnode->child[1]= oldnode->child[1];
rightnode->child[0]= newnode->child[0];
rightnode->child[1]= newnode->child[1];
break;
default:
fprintf(stderr,"T23 package internal logic bug #9\n");
return-1;
}


if(leftnode->child[0])leftnode->child[0]->parent= leftnode;
if(leftnode->child[1])leftnode->child[1]->parent= leftnode;
if(rightnode->child[0])rightnode->child[0]->parent= rightnode;
if(rightnode->child[1])rightnode->child[1]->parent= rightnode;

/*:34*/
#line 397 "23tree.w"

/*35:*/
#line 554 "23tree.w"


if(oldnode->parent==NULL){
*rootp= middlenode;
free(oldnode);
free(newnode);
return 0;
}else{
T23 old_oldnode= oldnode;

oldnode= oldnode->parent;
free(old_oldnode);
free(newnode);
newnode= middlenode;
newkey= newnode->key[0];

}


/*:35*/
#line 398 "23tree.w"

}
}
}

/*:29*/
#line 361 "23tree.w"


/*:26*//*49:*/
#line 770 "23tree.w"


/*47:*/
#line 762 "23tree.w"


static T23 makenewnode(T23_KEY key)

/*:47*/
#line 772 "23tree.w"
{

T23 temp;

temp= (T23)(malloc(sizeof(struct t23_st_node)));

temp->parent= NULL;

temp->child[0]= NULL;
temp->child[1]= NULL;
temp->child[2]= NULL;

temp->key[0]= key;
temp->key[1]= NULL;

temp->numkeys= 1;

return temp;
}

/*:49*//*53:*/
#line 809 "23tree.w"


/*51:*/
#line 801 "23tree.w"


static T23 leftmost_child(T23 node)

/*:51*/
#line 811 "23tree.w"

{
if(node->child[0])return leftmost_child(node->child[0]);
else return node;
}

/*:53*/
#line 58 "23tree.w"


/*:2*/
